<?php
/**
 * --------------------------------------------------------------------------------
 * APP - image popup
 * --------------------------------------------------------------------------------
 * @package     Joomla  3.x
 * @subpackage  J2 Store
 * @author      Alagesan, J2Store <support@j2store.org>
 * @copyright   Copyright (c) 2016 J2Store . All rights reserved.
 * @license     GNU/GPL license: http://www.gnu.org/licenses/gpl-2.0.html
 * @link        http://j2store.org
 * --------------------------------------------------------------------------------
 *
 * */
defined('_JEXEC') or die('Restricted access');
require_once(JPATH_ADMINISTRATOR.'/components/com_j2store/library/plugins/app.php');
class plgJ2StoreApp_imagepopup extends J2StoreAppPlugin
{
    /**
     * @var $_element  string  Should always correspond with the plugin's filename,
     *                         forcing it to be unique
     */
    var $_element = 'app_imagepopup';

    function __construct(&$subject, $config)
    {
        parent::__construct($subject, $config);
        JFactory::getLanguage()->load('plg_j2store_' . $this->_element, JPATH_ADMINISTRATOR);
    }

    /**
     * Overriding
     *
     * @param $options
     * @return unknown_type
     */
    function onJ2StoreGetAppView($row)
    {

        if (!$this->_isMe($row)) {
            return null;
        }

        $html = $this->viewList();


        return $html;
    }

    /**
     * Validates the data submitted based on the suffix provided
     * A controller for this plugin, you could say
     *
     * @param $task
     * @return html
     */
    function viewList()
    {
        $app = JFactory::getApplication();
        JToolBarHelper::title(JText::_('J2STORE_APP') . '-' . JText::_('PLG_J2STORE_' . strtoupper($this->_element)), 'j2store-logo');
        JToolBarHelper::apply('apply');
        JToolBarHelper::save();
        JToolBarHelper::back('PLG_J2STORE_BACK_TO_APPS', 'index.php?option=com_j2store&view=apps');
        JToolBarHelper::back('J2STORE_BACK_TO_DASHBOARD', 'index.php?option=com_j2store');

        $id = $app->input->get('id', 0);
        $vars = new JObject();
        //model should always be a plural
        $this->includeCustomModel('AppImagepopups');
        $model = F0FModel::getTmpInstance('AppImagepopups', 'J2StoreModel');
        $data = $this->params->toArray();
        $newdata = array();
        $newdata['params'] = $data;
        $form = $model->getForm($newdata);
        $vars->form = $form;
        $vars->id = $id;
        $vars->cp_user = array();
        $vars->action = "index.php?option=com_j2store&view=app&task=view&id={$id}";
        $html = $this->_getLayout('default', $vars);
        return $html;
    }

    function onJ2StoreBeforeDisplayImages(&$images, $view, $context){
        $vars = new stdClass();
        $vars->view = $view;
        $vars->context = $context;
        $show_image_popup =$this->params->get('list_view_display',0);
        //include
        if(in_array($context, array('com_j2store.products.view.default','com_j2store.products.view.bootstrap'))){
            $popup_type = $this->params->get('popup_type',1);
            if ($popup_type == 3) {return false;} //S63 added to show magnify zoom
            if($popup_type == 0){
                $images = $this->_getLayout('photoswipe', $vars);
            }elseif($popup_type == 1){
                $images = $this->_getLayout('lightgallery', $vars);
            }else{
                $images = $this->_getLayout('fancybox', $vars);
            }

        }elseif(in_array($context, array('com_j2store.products.list.default','com_j2store.products.list.bootstrap')) && $show_image_popup){
            $popup_type = $this->params->get('popup_type',1);
            if ($popup_type == 3) {return false;} //S63 added to show magnify zoom
            if($popup_type == 0){
                $images = $this->_getLayout('photoswipe_list', $vars);
            }elseif($popup_type == 1){
                $images = $this->_getLayout('lightgallery_list', $vars);
            }else{
                $images = $this->_getLayout('fancybox_list', $vars);
            }
        }
    }
    public function onJ2StoreBeforeRenderingProductHtml($view){
        $this->loadImageScript();
    }
    public function onJ2StoreViewProductList(&$items, &$view, $params, $model){
        $show_image_popup =$this->params->get('list_view_display',0);
        if($show_image_popup){
            $this->loadImageScript();
        }
    }

    public function onJ2StoreViewProduct(&$product, &$view){
        $this->loadImageScript();
    }

    public function loadImageScript(){
        $popup_type = $this->params->get('popup_type',1);
        $document = JFactory::getDocument();
        if($popup_type == 0){
            //photoswipe css
            $photoswipe_css = JUri::base(true) . '/plugins/j2store/' . $this->_element . '/' . $this->_element . '/assert/photoswipe/css/photoswipe.css';
            $photoswipe_skin = JUri::base(true) . '/plugins/j2store/' . $this->_element . '/' . $this->_element . '/assert/photoswipe/css/default-skin.css';

//photoswipe js
            $photoswipe_min = JUri::base(true) . '/plugins/j2store/' . $this->_element . '/' . $this->_element . '/assert/photoswipe/js/photoswipe.min.js';
            $ui_min = JUri::base(true) . '/plugins/j2store/' . $this->_element . '/' . $this->_element . '/assert/photoswipe/js/photoswipe-ui-default.min.js';

            $document->addStyleSheet($photoswipe_css);
            $document->addStyleSheet($photoswipe_skin);
            $document->addScript($photoswipe_min);
            $document->addScript($ui_min);
            $script_file = "jQuery(document).ready(function($){
        jQuery( 'body' ).on( 'after_doAjaxFilter', function( e, product, response ){
            var product_id = product.find('.j2store-addtocart-form').data('product_id');
            $(\".demo-gallery-\"+product_id+\" .demo-gallery__img--main\").attr('href', response.main_image);
            $(\".demo-gallery-\"+product_id+\" .demo-gallery__img--main\").attr('data-med', response.main_image);
            $(\".demo-gallery-\"+product_id+\" .demo-gallery__img--main img\").attr('src', response.main_image);
        });
    });";
            $document->addScriptDeclaration ( $script_file );
        }elseif($popup_type == 1){
            $custom = JUri::base(true) . '/plugins/j2store/' . $this->_element . '/' . $this->_element . '/assert/light/css/custom.css';
            $gallery = JUri::base(true) . '/plugins/j2store/' . $this->_element . '/' . $this->_element . '/assert/light/css/lightgallery.css';
            $document->addStyleSheet ( $custom );
            $document->addStyleSheet ( $gallery );

            $picturefill = JUri::base(true) . '/plugins/j2store/' . $this->_element . '/' . $this->_element . '/assert/light/js/picturefill.min.js';
            $lightgallery = JUri::base(true) . '/plugins/j2store/' . $this->_element . '/' . $this->_element . '/assert/light/js/lightgallery.js';
            $fullscreen = JUri::base(true) . '/plugins/j2store/' . $this->_element . '/' . $this->_element . '/assert/light/js/lg-fullscreen.js';
            $thumbnail = JUri::base(true) . '/plugins/j2store/' . $this->_element . '/' . $this->_element . '/assert/light/js/lg-thumbnail.js';
            $video = JUri::base(true) . '/plugins/j2store/' . $this->_element . '/' . $this->_element . '/assert/light/js/lg-video.js';
            $autoplay = JUri::base(true) . '/plugins/j2store/' . $this->_element . '/' . $this->_element . '/assert/light/js/lg-autoplay.js';
            $zoom = JUri::base(true) . '/plugins/j2store/' . $this->_element . '/' . $this->_element . '/assert/light/js/lg-zoom.js';
            $hash = JUri::base(true) . '/plugins/j2store/' . $this->_element . '/' . $this->_element . '/assert/light/js/lg-hash.js';
            $pager = JUri::base(true) . '/plugins/j2store/' . $this->_element . '/' . $this->_element . '/assert/light/js/lg-pager.js';
            $mousewheel = JUri::base(true) . '/plugins/j2store/' . $this->_element . '/' . $this->_element . '/assert/light/js/jquery.mousewheel.min.js';

            $document->addScript ( $picturefill );
            $document->addScript ( $lightgallery );
            $document->addScript ( $fullscreen );
            $document->addScript ( $thumbnail );
            $document->addScript ( $video );
            $document->addScript ( $autoplay );
            $document->addScript ( $zoom );
            $document->addScript ( $hash );
            $document->addScript ( $pager );
            $document->addScript ( $mousewheel );
            $script_file = "jQuery(document).ready(function($){
        jQuery( 'body' ).on( 'after_doAjaxFilter', function( e, product, response ){
            var product_id = product.find('.j2store-addtocart-form').data('product_id');
            
            $(\"#lightgallery-\"+product_id+\" .light-main-span\").attr('data-responsive', response.main_image);
            $(\"#lightgallery-\"+product_id+\" .light-main-span\").attr('data-src', response.main_image);
            $(\"#lightgallery-\"+product_id+\" .light-main-span img\").attr('src', response.main_image);
            $('#lightgallery-'+product_id).lightGallery();
        });
    });";
            $document->addScriptDeclaration ( $script_file );
        }else{
            $fancy_css = JUri::base(true) .'/plugins/j2store/' . $this->_element . '/' . $this->_element . '/assert/fancybox/jquery.fancybox.css';
            $fancy_mousewheel = JUri::base(true) .'/plugins/j2store/' . $this->_element . '/' . $this->_element . '/assert/fancybox/jquery.mousewheel.pack.js';
            $fancy_js = JUri::base(true) .'/plugins/j2store/' . $this->_element . '/' . $this->_element . '/assert/fancybox/jquery.fancybox.pack.js';

            $document->addStyleSheet($fancy_css);
            $document->addScript($fancy_mousewheel);
            $document->addScript($fancy_js);
            $script_file = " function changeFancy(product_id) {
        (function ($) {
            $(\".fancyj2store-\"+product_id+\" a[rel=example_group]\").fancybox({
                prevEffect		: 'none',
                nextEffect		: 'none',
                closeBtn		: true
            });
        })(jQuery);
    }
    jQuery(document).ready(function($){
        $( 'body' ).on( 'after_doAjaxFilter', function( e, product, response ){
            var product_id = product.find('.j2store-addtocart-form').data('product_id');
            $(\".fancyj2store-\"+product_id+\" .main-image-fancy\").attr('href', response.main_image);
            $(\".fancyj2store-\"+product_id+\" .main-image-fancy img\").attr('src', response.main_image);
            changeFancy(product_id);
        });
    });";
            $document->addScriptDeclaration ( $script_file );
        }
    }
}