<?php
/**
 * --------------------------------------------------------------------------------
 * Apps Plugin - order files
 * --------------------------------------------------------------------------------
 * @package     Joomla 3.x
 * @subpackage  J2 Store
 * @author      Alagesan, J2Store <support@j2store.org>
 * @copyright   Copyright (c) 2016 J2Store . All rights reserved.
 * @license     GNU/GPL license: http://www.gnu.org/licenses/gpl-2.0.html
 * @link        http://j2store.org
 * --------------------------------------------------------------------------------
 *
 * */
//S63 1 line changed from media/j2store/uploads to attachments/store
/** ensure this file is being included by a parent file */
defined('_JEXEC') or die('Restricted access');
require_once(JPATH_ADMINISTRATOR.'/components/com_j2store/library/plugins/app.php');
class plgJ2StoreApp_orderfiles extends J2StoreAppPlugin
{
    /**
     * @var $_element  string  Should always correspond with the plugin's filename,
     *                         forcing it to be unique
     */
    var $_element = 'app_orderfiles';

    /**
     * Overriding
     *
     * @param $options
     * @return unknown_type
     */
    function onJ2StoreGetAppView($row)
    {

        if (!$this->_isMe($row)) {
            return null;
        }

        $html = $this->viewList();


        return $html;
    }

    /**
     * Validates the data submitted based on the suffix provided
     * A controller for this plugin, you could say
     *
     * @param $task
     * @return html
     */
    function viewList()
    {
        $app = JFactory::getApplication();
        JToolBarHelper::title(JText::_('J2STORE_APP') . '-' . JText::_('PLG_J2STORE_' . strtoupper($this->_element)), 'j2store-logo');
        JToolBarHelper::apply('apply');
        JToolBarHelper::save();
        JToolBarHelper::back('PLG_J2STORE_BACK_TO_APPS', 'index.php?option=com_j2store&view=apps');
        JToolBarHelper::back('J2STORE_BACK_TO_DASHBOARD', 'index.php?option=com_j2store');
        JToolbarHelper::back('<i class="fa fa-th-list"></i> '.JText::_('J2STORE_APP_ORDERFILES_LIST'), 'index.php?option=com_j2store&view=apps&task=view&id='.$app->input->getInt('id').'&appTask=displayList');
        $vars = new JObject();
        //model should always be a plural
        $this->includeCustomModel('AppOrderfiles');

        $model = F0FModel::getTmpInstance('AppOrderfiles', 'J2StoreModel');
     
        $data = $this->params->toArray();
        $newdata = array();
        $newdata['params'] = $data;
        $form = $model->getForm($newdata);
        $vars->form = $form;
        $id = $app->input->getInt('id', '0');
        $vars->id = $id;
        $vars->action = "index.php?option=com_j2store&view=app&task=view&id={$id}";
        $html = $this->_getLayout('default', $vars);
        return $html;
    }

    public function onJ2StoreCheckoutGuest($view){
        $html = $this->displayFileUpload('billing');
        return $html;
    }


    public function onJ2StoreCheckoutValidateGuest(&$json,&$data){
        if(!$json){
            $this->uploadIds($data,'billing');
        }
    }

    public function onJ2StoreCheckoutGuestShipping($view){
        $html = $this->displayFileUpload('shipping');
        return $html;
    }

    public function onJ2StoreCheckoutValidateGuestShipping(&$json,&$data){
        if(!$json){
            $this->uploadIds($data,'shipping');
        }
    }

    public function onJ2StoreCheckoutRegister($view){
        $html = $this->displayFileUpload('billing');
        return $html;
    }

    public function onJ2StoreCheckoutBilling($view){
        $html = $this->displayFileUpload('billing');
        return $html;
    }

    public function onJ2StoreCheckoutShipping($view){
        $html = $this->displayFileUpload('shipping');
        return $html;
    }

    public function onJ2StoreAfterDisplayShippingPayment($order){
        $html = $this->displayFileUpload('payment');
        return $html;
    }

    public function displayFileUpload($check_type){
        $type = $this->params->get('display_place','');
        $html = "";
        if($type == $check_type){
            $upload_count = (int)$this->params->get('upload_count',1);
            for($i = 0; $i<$upload_count ;$i++) {
                F0FTable::addIncludePath(JPATH_ADMINISTRATOR.'/components/com_j2store/tables');
                $app_table = F0FTable::getInstance('App', 'J2StoreTable')->getClone();
                $app_table->load(array('element' => $this -> _element, 'folder' => 'j2store'));
                $vars = new JObject();
                $vars->id =$app_table->extension_id;
                $vars->button_id = "button-billing-address";
                $option = JFactory::getApplication()->input->get('option','');
                if($option == 'com_easycheckout'){
                    $vars->div_id = "easy-checkout-billing-address";
                }else{
                    $vars->div_id = "billing-new";
                }
                $vars->after_display = $this->params->get('after_field','company');
                if($type=='shipping'){
                    $vars->button_id = "button-shipping-address";

                    if($option == 'com_easycheckout'){
                        $vars->div_id = "easy-checkout-shipping-address";
                        $vars->after_display = 'shipping_'.$vars->after_display;
                    }else{
                        $vars->div_id = "shipping-new";
                    }
                }
                if($type == 'payment'){
                    $vars->button_id = "button-payment-method";
                    $vars->div_id = "shipping-payment-method";
                    $vars->after_display = 'customer_note';
                }
                $vars->count = $i;

                $html .= $this->_getLayout('orderfile_layout', $vars);
            }
        }
        return $html;
    }

    function uploadIds($post,$dis_type,$return = false){
        $upload_count = (int)$this->params->get('upload_count',1);
        $type = $this->params->get('display_place','');
        if($type == $dis_type){
            $upload_ids = array();
            for($i = 0; $i<$upload_count;$i++){
                $key = "orderfile".$i."_id";
                $upload_id = (isset($post[$key]) && !empty($post[$key])) ? $post[$key]:0;
                if($upload_id){
                    $upload_ids[] = $upload_id;
                }
            }
            $session = JFactory::getSession();
            $session->set('orderfile_upload_ids',implode(',', $upload_ids),'j2store');
        }

        if($return){
            return $upload_ids;
        }
    }

    public function onJ2StoreCheckoutValidateRegister(&$json){
        $app = JFactory::getApplication();
        if(!$json){
            $post = $app->input->getArray($_REQUEST);
            $this->uploadIds($post,'billing');
        }
    }

    /**
     * billing address image upload save
     *
     * */
    public function onJ2StoreCheckoutValidateBilling(&$json){
        $app = JFactory::getApplication();
        if(!$json){
            $post = $app->input->getArray($_REQUEST);
            $this->uploadIds($post,'billing');
        }
    }

    /**
     * shipping address image upload save
     *
     * */
    public function onJ2StoreCheckoutValidateShipping(&$json){
        $app = JFactory::getApplication();
        if(!$json){
            $post = $app->input->getArray($_REQUEST);
            $this->uploadIds($post,'shipping');
        }
    }

    /**
     * Method to save the upload file before payment
     * @param string $orderpayment_type
     * @param array $values
     */
    public function  onJ2StorePrePayment($orderpayment_type,$post) {
        $app = JFactory::getApplication();
        $type = $this->params->get('display_place','');
        $session = JFactory::getSession();
        $view = $app->input->get('option','');
        if( $view == 'com_easycheckout'){
            $upload_ids = $session->get('itemid_docs', '', 'j2store');
            $session->clear('itemid_docs', 'j2store');
        }else {
            if ($type == 'payment') {
                $data = $app->input->getArray($_REQUEST);
                $upload_ids = $this->uploadIds($data, 'payment', true);
            } else {
                $session = JFactory::getSession();
                $upload_ids = $session->get('orderfile_upload_ids', '', 'j2store');
                if (!empty($upload_ids)) {
                    $upload_ids = explode(',', $upload_ids);
                } else {
                    $upload_ids = array();
                }
            }
        }
        $upload_file = array(
            'upload_ids' => $upload_ids
        );

        $order = F0FTable::getInstance('Order', 'J2StoreTable')->getClone();
        $order->load(array(
            'order_id' => $post['order_id']
        ));
        if(!is_null($order->order_params) && $this->isJson($order->order_params)){
            $order_params = new JRegistry($order->order_params);
        }else{
            $order_params = new JRegistry('{}');
        }
        $order_params->set('app_orderfiles',$upload_file);
        $order->order_params = $order_params->toString();
        $order->store();
    }

    public function onJ2StoreCheckoutValidateShippingPayment($plugin_data, $order,&$json = array()){
        $app = JFactory::getApplication();
        $view = $app->input->get('option','');
        if($view == 'com_easycheckout'){
            $session = JFactory::getSession();
            $upload_count = (int)$this->params->get('upload_count',1);
            $app_docs = array();
            for ($i = 0; $i < $upload_count; $i++) {
                if (isset($plugin_data['orderfile' . $i . '_id'])) {
                    $app_docs[] = $plugin_data['orderfile' . $i . '_id'];
                }
            }
            $session->set('itemid_docs', $app_docs, 'j2store');
        }
    }

    function onJ2StoreAdminOrderAfterGeneralInformation($view){
        $order = $view->order;
        $this->includeCustomModel('AppOrderfiles');
        $model = F0FModel::getTmpInstance('AppOrderfiles', 'J2StoreModel');
        $data = json_decode($order->order_params);
        $vars = new stdClass();
        $vars->upload_files = array();
        if(isset($data->app_orderfiles->upload_ids)){
            $vars->upload_files = $model->getUploadFiles($data->app_orderfiles->upload_ids);
        }
        $vars->order_id = $order->order_id;
        $vars->view_order = 'order';
        $vars->id = $model->getAppId();
        $html = $this->_getLayout('orderfile_tabcontent', $vars);
        return $html;
    }

    function isJson($string) {
        json_decode($string);
        return (json_last_error() == JSON_ERROR_NONE);
    }


    public function onJ2StoreAfterProcessTags(&$text, $order, $tags){
        // Do process tag here
        if(!empty( $order->order_params )) {
            $order_table_params = json_decode($order->order_params, true);
            if(isset( $order_table_params['app_orderfiles']['upload_ids'] ) && $order_table_params['app_orderfiles']['upload_ids']){
                $vars = new stdClass();
                $vars->download_files = array();
                foreach ($order_table_params['app_orderfiles']['upload_ids'] as $key=>$up_id){
                    $file = F0FTable::getAnInstance( 'Upload', 'J2StoreTable' )->getClone();
                    $file->load($up_id);
                    $download_file = array();
                    $download_file['path'] = JUri::root().'attachments/store/'.$file->saved_name;
                    $download_file['name'] = $file->original_name;
                    $vars->download_files[] = $download_file;
                }
                $file_html = $this->_getLayout('orderedit_download', $vars);
                $app_tags = array(
                    '[ORDERFILE_NOTIFY]' => JText::_('J2STORE_APP_ORDERFILES_NOTIFY_TEXT'),
                    '[ORDERFILE_LIST]' => $file_html
                );
                foreach ($app_tags as $tag_key => $tag_value){
                    $text = str_replace($tag_key, $tag_value, $text);
                }
            }
        }
    }

    public function onJ2StoreAdminOrderListTab(){
        $this->includeCustomModel('AppOrderfiles');
        $model = F0FModel::getTmpInstance('AppOrderfiles', 'J2StoreModel');
        $vars = new stdClass();
        $vars->id = $model->getAppId();
        $vars->view_order = 'orders';
        $html = $this->_getLayout('orderfile_tab', $vars);
        return $html;
    }
    public function onJ2StoreAdminOrderListTabContent($order){
        $this->includeCustomModel('AppOrderfiles');
        $model = F0FModel::getTmpInstance('AppOrderfiles', 'J2StoreModel');
        $data = json_decode($order->order_params);
        $vars = new stdClass();
        $vars->upload_files = array();
        if(isset($data->app_orderfiles->upload_ids)){
            $vars->upload_files = $model->getUploadFiles($data->app_orderfiles->upload_ids);
        }
        $vars->order_id = $order->order_id;
        $html = $this->_getLayout('orderfile_tabcontent', $vars);
        return $html;

    }
}