<?php
/**
 * --------------------------------------------------------------------------------
 * Apps Plugin - order files
 * --------------------------------------------------------------------------------
 * @package     Joomla 3.x
 * @subpackage  J2 Store
 * @author      Alagesan, J2Store <support@j2store.org>
 * @copyright   Copyright (c) 2016 J2Store . All rights reserved.
 * @license     GNU/GPL license: http://www.gnu.org/licenses/gpl-2.0.html
 * @link        http://j2store.org
 * --------------------------------------------------------------------------------
 *
 * */
//S63 2 line change from media/j2store/uploads to attachments/store
defined ( '_JEXEC' ) or die ( 'Restricted access' );

require_once (JPATH_ADMINISTRATOR . '/components/com_j2store/library/appcontroller.php');
class J2StoreControllerAppOrderfiles extends J2StoreAppController
{
    var $_element = 'app_orderfiles';

    function __construct()
    {
        parent::__construct();
        F0FModel::addIncludePath(JPATH_ADMINISTRATOR.'/components/com_j2store/models');
        JFactory::getLanguage ()->load ( 'plg_j2store_' . $this->_element, JPATH_ADMINISTRATOR );
        $this->registerTask ( 'apply', 'save' );
    }

    function save() {
        $app = JFactory::getApplication ();
        $data = $app->input->getArray ( $_POST );
        $data['params']  = $app->input->post->get('params', array(), 'array');
        $save_params = new JRegistry ();
        $save_params->loadArray ( $data['params'] );
        $json = $save_params->toString ();

        $db = JFactory::getDbo ();

        $query = $db->getQuery ( true )->update ( $db->qn ( '#__extensions' ) )->set ( $db->qn ( 'params' ) . ' = ' . $db->q ( $json ) )->where ( $db->qn ( 'element' ) . ' = ' . $db->q ( $this->_element ) )->where ( $db->qn ( 'folder' ) . ' = ' . $db->q ( 'j2store' ) )->where ( $db->qn ( 'type' ) . ' = ' . $db->q ( 'plugin' ) );

        $db->setQuery ( $query );
        $db->execute ();
        if ($data ['appTask'] == 'apply' && isset ( $data ['app_id'] )) {
            $url = 'index.php?option=com_j2store&view=apps&task=view&id=' . $data ['app_id'];
        } else {
            $url = 'index.php?option=com_j2store&view=apps';
        }
        jimport('joomla.application.component.helper');
        if(isset( $data['params']['upload_extensions'] ) && !empty( $data['params']['upload_extensions'] )){
            //$upload_extension = JComponentHelper::getParams('com_media')->set('upload_extensions',$data['upload_extensions']);
            $this->updateMediaparams('upload_extensions',$data['params']['upload_extensions']);
        }

        $this->setRedirect ( $url );
    }

    function updateMediaparams($name,$value){

        $db = JFactory::getDBo();
        $query = $db->getQuery(true);
        $query->select('*');
        $query->from('#__extensions');
        $query->where('element ='.$db->q('com_media'));
        $query->where('type ='.$db->q('component'));
        $db->setQuery($query);
        $media = $db->loadObject();
        $object = new stdClass();
        $params = new JRegistry;
        $params->loadString($media->params);
        $params->set($name,$value);

        // Must be a valid primary key value.
        $object->extension_id = $media->extension_id;
        $object->params = $params->toString();
        // Update their details in the users table using id as the primary key.
        JFactory::getDbo()->updateObject('#__extensions', $object, 'extension_id');

    }

    protected function onBeforeGenericTask($task)
    {
        $privilege = $this->configProvider->get(
            $this->component . '.views.' .
            F0FInflector::singularize($this->view) . '.acl.' . $task, ''
        );

        return $this->allowedTasks($task);
    }

    function allowedTasks($task)
    {
        $allowed = array('uploadOrderfile','displayList','singleDelete','bulkDelete','fileDownload');
        if (in_array($task, $allowed)) {
            return true;
        }
        return false;
    }

    function uploadOrderfile(){
        $app = JFactory::getApplication();
        $files = $app->input->files->get('file');
        $json = array();
        $this->includeCustomModel('AppOrderfiles');
        $model = F0FModel::getTmpInstance('AppOrderfiles', 'J2StoreModel');
        $json = $model->validate_files($files);
        echo json_encode($json);
        $app->close();
    }

    /**
     * Include a particular Custom Model
     * @param $name the name of the model
     * @param $plugin the name of the plugin in which the model is stored
     * @param $group the group of the plugin
     */
    protected function includeCustomModel($name, $plugin = '', $group = 'j2store') {
        if (empty($plugin)) {
            $plugin = $this -> _element;
        }
        if (!class_exists('J2StoreModel' . $name))
            JLoader::import('plugins.' . $group . '.' . $plugin . '.' . $plugin . '.models.' . strtolower($name), JPATH_SITE);
    }

    function displayList(){
        $app = JFactory::getApplication();
        $id = $app->input->get('id',0);
        $this->includeCustomModel('AppOrderfiles');
        $model = F0FModel::getTmpInstance('AppOrderfiles', 'J2StoreModel');
        $option = 'com_j2store';
        $ns = $option.'.app.'.$this->_element;
        $limit		= $app->getUserStateFromRequest( 'global.list.limit', 'limit', $app->getCfg('list_limit'), 'int' );
        $limitstart	= $app->getUserStateFromRequest( $ns.'.limitstart', 'limitstart', 0, 'int' );
        $limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);
        $filter_order_Dir =  $app->getUserStateFromRequest( $ns.'filter_order_Dir',	'filter_order_Dir',	'',	'word' );
        $filter_order	= $app->getUserStateFromRequest( $ns.'filter_order',		'filter_order',		'#__j2store_orders.order_id',	'cmd' );
        $search = $app->input->get('search','');
        $model->setState('limit', $limit);
        $model->setState('limitstart', $limitstart);
        $model->setState('filter_order_Dir', $filter_order_Dir);
        $model->setState('filter_order', $filter_order);
        $model->setState('search', $search);

        $list = $model->getList();
        $pagin = $model->getPagination();

        $vars = new stdClass();
        $vars->state = $model->getState();
        $model_app = F0FModel::getTmpInstance('Apps','J2StoreModel');
        $form = array();
        $form['action'] = "index.php?option=com_j2store&view=app&task=view&id={$id}";
        $view = $this->getView( 'Apps', 'html' );
        $view->setModel($model_app, true );
        $view->addTemplatePath(JPATH_SITE.'/plugins/j2store/'.$this->_element.'/'.$this->_element.'/tmpl');
        JToolBarHelper::back('PLG_J2STORE_BACK_TO_APPS', $form['action']);
        //link to Create new User
        $vars->form2 =  $form;
        $vars->limit = $limit;
        $vars->limitstart = $limitstart;
        $vars->id = $id;
        $vars->pagination = $pagin;
        $vars->list = $list;
        $view->set('vars',$vars);
        $view->setLayout('display_list');
        $view->display();
    }

    function singleDelete(){

        $app = JFactory::getApplication();
        $id = $app->input->get('id','');
        $upload_id = $app->input->get('upload_id','');
        $order_id = $app->input->get('order_id','');
        $json = array();
        if(!empty( $order_id )){
            $order = F0FTable::getAnInstance( 'Order', 'J2StoreTable' )->getClone();
            $order->load(array(
                'order_id' => $order_id
            ));
            $data = json_decode($order->order_params,true);
            $upload_list = $data['app_orderfiles'];//get('app_orderfiles',array());
            foreach ($upload_list['upload_ids'] as $key=>$up_id){
                if($up_id == $upload_id){
                    unset( $upload_list['upload_ids'][$key] );
                    $file = F0FTable::getAnInstance( 'Upload', 'J2StoreTable' )->getClone();
                    $file->load($up_id);

                    //echo $path = JUri::root().'media/j2store/uploads/'.$file->saved_name;
                    $path = JPATH_SITE."/attachments/store/".$file->saved_name;

                    if(JFile::exists($path)){
                        JFile::delete($path);
                    }
                    if($file->j2store_upload_id){
                        $file->delete();
                    }
                    break;
                }
            }
            if(empty( $upload_list['upload_ids'] )){
                unset( $data['app_orderfiles'] );
            }
            $order->order_params = json_encode ( $data ) ;
            $order->store();
        }
        $from = $app->input->get('from','');
        if($from == 'orders'){
            $url = "index.php?option=com_j2store&view=orders";
        }elseif($from == 'order'){
            $url = "index.php?option=com_j2store&view=order&id=".$order->j2store_order_id;
        }else{
            $url = "index.php?option=com_j2store&view=apps&task=view&id=".$id."&appTask=displayList";
        }
        $json['redirect'] = $url;
        echo json_encode ( $json );
        $app->close();
    }

    function bulkDelete(){
        $app = JFactory::getApplication();
        $id = $app->input->get('id','');
        $upload_ids = $app->input->get('cid',array());

        jimport('joomla.filesystem.file');
        $json =  array();

        foreach ($upload_ids as $key=>$j2store_order_id){

            $order = F0FTable::getAnInstance( 'Order', 'J2StoreTable' )->getClone();
            $order->load($j2store_order_id);

            $data = json_decode($order->order_params,true);
            $upload_list = isset( $data['app_orderfiles'] ) ? $data['app_orderfiles']: array();//get('app_orderfiles',array());
            if(isset( $upload_list['upload_ids'] )){
                foreach ($upload_list['upload_ids'] as $key=>$up_id){
                    // remove file
                    // remove upload table
                    // remove params
                    $file = F0FTable::getAnInstance( 'Upload', 'J2StoreTable' )->getClone();
                    $file->load($up_id);
                    $path = JPATH_SITE."/attachments/store/".$file->saved_name;
                    if(JFile::exists($path)){
                        JFile::delete($path);
                    }
                    if($file->j2store_upload_id){
                        $file->delete();
                    }
                }
            }
            if(isset( $data['app_orderfiles'] )){
                unset( $data['app_orderfiles'] );
            }
            $order->order_params = json_encode ( $data ) ;
            $order->store();
        }
        $json['redirect'] = "index.php?option=com_j2store&view=apps&task=view&id=".$id."&appTask=displayList";
        echo json_encode ( $json );
        $app->close();
    }

   
}