<?php
/**
 * --------------------------------------------------------------------------------
 * Apps Plugin - order files
 * --------------------------------------------------------------------------------
 * @package     Joomla 3.x
 * @subpackage  J2 Store
 * @author      Alagesan, J2Store <support@j2store.org>
 * @copyright   Copyright (c) 2016 J2Store . All rights reserved.
 * @license     GNU/GPL license: http://www.gnu.org/licenses/gpl-2.0.html
 * @link        http://j2store.org
 * --------------------------------------------------------------------------------
 *
 * */
//S63 3 line change from media/j2store/uploads to attachments/store
defined('_JEXEC') or die('Restricted access');
require_once (JPATH_ADMINISTRATOR . '/components/com_j2store/library/appmodel.php');
class J2StoreModelAppOrderfiles extends J2StoreAppModel
{
    public $_element = 'app_orderfiles';
    var $total = 0;
    function __construct()
    {
        parent::__construct();
        $app = JFactory::getApplication();
        $option = 'com_j2store';
        $ns = $option.'.apporderfiles';

        $limit		= $app->getUserStateFromRequest( 'global.list.limit', 'limit', $app->getCfg('list_limit'), 'int' );
        $limitstart	= $app->getUserStateFromRequest( $ns.'.limitstart', 'limitstart', 0, 'int' );
        $search = $app->input->get('search','');
        // In case limit has been changed, adjust limitstart accordingly
        $limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);
        $this->setState('limit', $limit);
        $this->setState('limitstart', $limitstart);
        $this->setState('search',$search);
    }

    public function buildQuery($overrideLimits = true)
    {
        $app = JFactory::getApplication();
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $query->select('*')->from('#__j2store_orders');
        $this->_buildQueryOrder($query);
        $this->_buildQueryGroup($query);
        $query->where('#__j2store_orders.order_params IS NOT NULL');
        $search = $this->getState('search','');
        if(!empty($search)){
            $search = '%'.trim($search).'%';
            $query->where(
                $db->qn('#__j2store_orders').'.'.$db->qn('user_email').' LIKE '.$db->q($search).'OR'.
                $db->qn('#__j2store_orders').'.'.$db->qn('order_id').' LIKE '.$db->q($search)
            );
        }
        return $query;
    }

    function _buildQueryOrder($query){
        $mainframe = JFactory::getApplication();
        $option = 'com_j2store';
        $ns = $option.'.apporderfiles';
        $filter_order		= $mainframe->getUserStateFromRequest( $ns.'filter_order',		'filter_order',		'#__j2store_orders.order_id',	'cmd' );
        $filter_order_Dir	= $mainframe->getUserStateFromRequest( $ns.'filter_order_Dir',	'filter_order_Dir',	'DESC',				'word' );

        $query->order('#__j2store_orders.order_id');
    }

    function _buildQueryGroup($query){
        $query->group('#__j2store_orders.j2store_order_id');
    }
    public function onProcessList(&$resultArray) {
        foreach($resultArray as $key=>$order){
            $data = json_decode($order->order_params);

            if(!isset($data->app_orderfiles) || (!isset($data->app_orderfiles->upload_ids)) || (isset( $data->app_orderfiles->upload_ids ) && (is_null ( $data->app_orderfiles->upload_ids ) ||empty( $data->app_orderfiles->upload_ids )))){//
                unset($resultArray[$key]);
            }else{
                if(isset($data->app_orderfiles->upload_ids)){
                    $resultArray[$key]->upload_files = $this->getUploadFiles($data->app_orderfiles->upload_ids);
                }
            }
        }
    }

    /*function &getList($overrideLimits=false, $group = ""){
        $query = $this->buildQuery();
        echo $query;
    }*/
    function getUploadFiles($upload_ids = array()){
        $files = array();
        if(!empty($upload_ids)){
            $db = JFactory::getDbo();
            $query = $db->getQuery(true);
            $query->select('*')->from('#__j2store_uploads')->where('#__j2store_uploads.j2store_upload_id IN('.implode(',',$upload_ids).')');
            $db->setQuery($query);
            $files = $db->loadObjectList();
        }
        return $files;
    }
    /*function setOrderTotal($total){
        $this->total = $total;
    }*/
    function getOrderTotal(){
        $query = $this->buildQuery();
        $total = $this->_getSFList((string) $query);
        return count($total);

    }
    protected function _getSFList($query, $limitstart = 0, $limit = 0, $group = '')
    {
        try {
            $this->_db->setQuery($query, $limitstart, $limit);
            $result = $this->_db->loadObjectList($group);
        } catch (Exception $e) {
            $result = array();
        }
        return $result;
    }
    public function getPagination()
    {
        // Import the pagination library
        JLoader::import('joomla.html.pagination');
        // Prepare pagination values
        //$total = $this->getSFPageTotal();
       $total = $this->getOrderTotal();

        // Create the pagination object
        $this->_sfpagination = new JPagination($total, $this->getStart($total), $this->getState('limit'));
        return $this->_sfpagination;
    }

    public function getStart()
    {
        $total = $this->getOrderTotal();
        $start = $this->getState('limitstart');
        $limit = $this->getState('limit');

        //$total = $this->getSFPageTotal();

        if ($start > $total - $limit)
        {
            $start = max(0, (int) (ceil($total / $limit) - 1) * $limit);
        }

        return $start;
    }
    public function validate_files($files = array()) {

        $app = JFactory::getApplication();
        $model = F0FModel::getTmpInstance('Carts','J2StoreModel');
        $json = array();
        if(count($files) < 1) $files = $app->input->files->get('file');
        $upload_result = $this->uploadFile($files);

        if(isset($upload_result['error'])){
            return $upload_result;
        }

        if(!isset($upload_result['error']) && empty($upload_result['error'])) {
            $upload = F0FTable::getInstance('Upload', 'J2StoreTable')->getClone();
            $upload->j2store_upload_id = null;
            $jdate = new JDate();
            $upload_result['created_by'] = JFactory::getUser()->id;
            $upload_result['created_on'] = $jdate->toSql();
            $upload_result['enabled']    = 1;
            if($upload->save($upload_result)) {
                $session = JFactory::getSession();
                $session->clear('app_orderfile_upload_id','j2store');
                // setting exclude tax
               // $session->set('app_orderfile_upload_id', $upload->j2store_upload_id,'j2store');

                $json['upload_id'] = $upload->j2store_upload_id;
                $json['name'] = $upload_result['original_name'];
                $json['code'] = $upload_result['mangled_name'];
                $json['success'] = JText::_('J2STORE_UPLOAD_SUCCESSFUL');
            }else{
                $json['error'] = JText::sprintf('J2STORE_UPLOAD_ERR_GENERIC_ERROR');
                return $json;
            }

        }
        return $json;
    }

    protected function uploadFile($file, $checkUpload = true)
    {
        $json = array();
        if (isset($file['name']))
        {
            JLoader::import('joomla.filesystem.file');

            // Can we upload this file type?
            if ($checkUpload)
            {

                if(!class_exists('MediaHelper')) {
                    require_once(JPATH_ADMINISTRATOR.'/components/com_media/helpers/media.php');
                }

                $err   = '';
                $paths = array(JPATH_ROOT, JPATH_ADMINISTRATOR);
                $jlang = JFactory::getLanguage();
                $jlang->load('com_media', $paths[0], 'en-GB', true);
                $jlang->load('com_media', $paths[0], null, true);
                $jlang->load('com_media', $paths[1], 'en-GB', true);
                $jlang->load('com_media', $paths[1], null, true);

                if (!MediaHelper::canUpload($file, $err))
                {
                    if (!empty($err))
                    {
                        $err = JText::_($err);
                    }
                    else
                    {
                        $app = JFactory::getApplication();
                        $errors = $app->getMessageQueue();

                        if (count($errors))
                        {
                            $error = array_pop($errors);
                            $err = $error['message'];
                        }
                        else
                        {
                            $err = '';
                        }
                    }

                    $content = file_get_contents($file['tmp_name']);
                    if (preg_match('/\<\?php/i', $content)) {
                        $err = JText::_('J2STORE_UPLOAD_FILE_PHP_TAGS');
                    }
                    if (!empty($err))
                    {
                        $json['error']= JText::_('J2STORE_UPLOAD_ERR_MEDIAHELPER_ERROR').' '.$err;

                        return $json;

                    }
                    else
                    {

                        $json['error']  = JText::_('J2STORE_UPLOAD_ERR_GENERIC_ERROR');
                        return $json;
                    }


                }
            }

            // Get a (very!) randomised name
            $serverkey = JFactory::getConfig()->get('secret','');
            $sig       = $file['name'].microtime().$serverkey;

            if(function_exists('sha256'))
            {
                $mangledname = sha256($sig);
            }
            elseif(function_exists('sha1'))
            {
                $mangledname = sha1($sig);
            }
            else
            {
                $mangledname = md5($sig);
            }
            $upload_folder_path = JPATH_ROOT.'/attachments/store';
            if(!JFolder::exists($upload_folder_path)) {
                if(!JFolder::create($upload_folder_path)) {
                    $json['error'] =  JText::_('J2STORE_UPLOAD_ERROR_FOLDER_PERMISSION_ERROR');
                    return $json;

                }
            }
            //sanitize file name
            $filename = basename(preg_replace('/[^a-zA-Z0-9\.\-\s+]/', '', html_entity_decode($file['name'], ENT_QUOTES, 'UTF-8')));

            $name = $this->checkFileName($filename); //. '.' . md5(mt_rand());
            // ...and its full path
            $filepath = JPath::clean(JPATH_ROOT.'/attachments/store/'.$name);

            // If we have a name clash, abort the upload
            if (!isset($json['error']) && JFile::exists($filepath))
            {
                $json['error'] = JText::_('J2STORE_UPLOAD_ERR_NAMECLASH');
                return $json;
            }

            // Do the upload
            if (!isset($json['error']) && $checkUpload)
            {
                if (!JFile::upload($file['tmp_name'], $filepath))
                {
                    $json['error']=JText::_('J2STORE_UPLOAD_ERR_CANTJFILEUPLOAD');
                    return $json;
                }
            }
            else
            {
                if (!JFile::copy($file['tmp_name'], $filepath))
                {
                    $json['error']= JText::_('J2STORE_UPLOAD_ERR_CANTJFILEUPLOAD');
                    return $json;

                }
            }

            // Get the MIME type
            if(!isset($json['error']) && function_exists('mime_content_type'))
            {
                $mime = mime_content_type($filepath);
            }
            elseif(function_exists('finfo_open'))
            {
                $finfo = finfo_open(FILEINFO_MIME_TYPE);
                $mime = finfo_file($finfo, $filepath);
            }
            else
            {
                $mime = 'application/octet-stream';
            }

            if(!isset($json['error'])){
                // Return the file info
                return array(
                    'original_name'	=> $file['name'],
                    'mangled_name'	=> $mangledname,
                    'saved_name'	=> $name,
                    'mime_type'			=> $mime
                );
            }
        }
        else
        {
            $json['error'] =JText::_('J2STORE_ATTACHMENTS_ERR_NOFILE');
        }

        return $json;
    }

    public function checkFileName($file_name){
        $filepath = JPath::clean(JPATH_ROOT.'/attachments/store/'.$file_name);
        if(JFile::exists($filepath)){
            $path_parts = pathinfo($filepath);
            $file_name = $path_parts['filename']."_".rand(0, 9).'.'.$path_parts['extension'];
            return $this->checkFileName($file_name);
        }
        return $file_name;
    }

    public function getAppId(){
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $query->select('extension_id')->from('#__extensions')
            ->where('type ='.$db->q('plugin'))
            ->where('element ='.$db->q($this->_element))
            ->where('folder ='.$db->q('j2store'));
        $db->setQuery($query);
        return $db->loadResult();
    }
}