<?php
/**
 * --------------------------------------------------------------------------------
 * Apps Plugin - order files
 * --------------------------------------------------------------------------------
 * @package     Joomla 3.x
 * @subpackage  J2 Store
 * @author      Alagesan, J2Store <support@j2store.org>
 * @copyright   Copyright (c) 2016 J2Store . All rights reserved.
 * @license     GNU/GPL license: http://www.gnu.org/licenses/gpl-2.0.html
 * @link        http://j2store.org
 * --------------------------------------------------------------------------------
 *
 * */
//S63 1 line changed from media/j2store/uploads to attachments/store
defined('_JEXEC') or die('Restricted access');
$listOrder = $this->vars->state->get ( 'filter_order', 'tbl.user_id' );
$listDirn = $this->vars->state->get ( 'filter_order_Dir' );
$search = $this->vars->state->get ( 'search' );
$document =JFactory::getDocument();
$document->addScript(JURI::root(true).'/media/system/js/core.js');
?>
<div class="apporderfiles">
    <form action="<?php echo $this->vars->form2['action'];?>" name="adminForm" id="adminForm" method="post" >
        <label>
            <?php echo JText::_('J2STORE_APP_ORDERFILES_SEARCH');?>
        </label>
        <?php echo  J2Html::text('search',$search,array('id'=>'search' ,'class'=>'input j2store-order-filters'));?>
        <?php  echo  J2Html::button('go',JText::_( 'J2STORE_FILTER_GO' ) ,array('class'=>'btn btn-success' ,'onclick'=>'this.form.submit();'));?>
        <?php  echo  J2Html::button('reset',JText::_( 'J2STORE_FILTER_RESET' ),array('id'=>'reset-filter-search','class'=>'btn btn-inverse'));?>
        <input type="hidden" name="view" value="app" />
        <input type="hidden" name="option" value="com_j2store" />
        <input type="hidden" name="filter_order" value="<?php echo $listOrder; ?>" />
        <input type="hidden" name="filter_order_Dir" value="<?php echo $listDirn; ?>" />
        <input type="hidden" id="appTask" name="appTask" value="displayList" />
        <input type="hidden" name="task" value="view" />
        <?php echo J2Html::hidden('boxchecked',0);?>
        <input type="hidden" name="id" value="<?php echo $this->vars->id; ?>" />

        <span class="pull-right">
            <a href="#" class="btn btn-danger" onclick="bulkDelete()">Bulk Delete</a>
		<?php echo $this->vars->pagination->getLimitBox();?>
		</span>
        <table class="table table-striped table-bordered">
            <thead>
            <tr>
                <th width="1px">
                    <input type="checkbox" name="checkall-toggle" value="" title="<?php echo JText::_('JGLOBAL_CHECK_ALL'); ?>" onclick="Joomla.checkAll(this)" />
                </th>
                <th><?php echo JText::_('J2STORE_INVOICE');?></th>
                <th><?php echo JText::_('J2STORE_APP_ORDERFILES_ORDER_ID');?></th>
                <th><?php echo JText::_('J2STORE_APP_ORDERFILES_EMAIL');?></th>
                <th><?php echo JText::_('J2STORE_APP_ORDERFILES_FILES');?></th>
            </tr>
            </thead>
            <tfoot>
            <tr>
                <td colspan="5"><?php echo $this->vars->pagination->getListFooter(); ?></td>
            </tr>
            </tfoot>
            <tbody>
            <?php if(count($this->vars->list)):?>
                <?php foreach($this->vars->list as $i=>$list):?>
                    <?php $order = F0FTable::getAnInstance( 'Order', 'J2StoreTable' )->getClone();
                    $order->load(array(
                        'order_id' => $list->order_id
                    ));
                    $invoice_number = $order->getInvoiceNumber();
                   
                    ?>
                    <tr>
                        <td> <?php echo JHtml::_('grid.id',$i,$list->j2store_order_id); ?> </td>
                        <td><a href="index.php?option=com_j2store&view=order&id=<?php echo $list->j2store_order_id;?>"><?php echo $invoice_number;?></a></td>
                        <td><a href="index.php?option=com_j2store&view=order&id=<?php echo $list->j2store_order_id;?>"><?php echo $list->order_id;?></a></td>
                        <td><?php echo $list->user_email;?></td>
                        <td>
                            <table class="table table-striped table-bordered">
                                <tr>
                                    <th><?php echo JText::_('J2STORE_APP_ORDERFILES_FILE_NAME');?></th>
                                    <th><?php echo JText::_('J2STORE_APP_ORDERFILES_FILE_PATH');?></th>
                                </tr>
                                <?php foreach($list->upload_files as $file):?>
                                    <tr>
                                        <td><?php echo $file->original_name;?></td>
                                        <td><a href="<?php echo JUri::root();?>attachments/store/<?php echo $file->saved_name;?>" class="btn btn-primary" download><?php echo JText::_('J2STORE_DOWNLOAD')?></a></td>
                                        <td><a href="#" onclick="deleteSingle('<?php echo $file->j2store_upload_id;?>','<?php echo $list->order_id;?>')" class="btn btn-danger"><?php echo JText::_('J2STORE_DELETE');?></a></td>
                                    </tr>
                                <?php endforeach;?>
                            </table>
                        </td>

                    </tr>
                <?php endforeach;?>
            <?php else:?>
                <tr>
                    <td colspan="5">No item found</td>
                </tr>
            <?php endif;?>
            </tbody>
        </table>
    </form>
</div>
<script>
jQuery("#reset-filter-search").on('click',function(){
    jQuery("#search").attr('value','');
    this.form.submit();
});
if(typeof(j2store) == 'undefined') {
    var j2store = {};
}
if(typeof(j2store.jQuery) == 'undefined') {
    j2store.jQuery = jQuery.noConflict();
}

function bulkDelete() {
    (function ($) {
        var form_data = $('#adminForm input[type=checkbox]').serializeArray();
        $.ajax({
            type : 'post',
            url :  j2storeURL+'index.php?option=com_j2store&view=apps&task=view&id=<?php echo $this->vars->id;?>&appTask=bulkDelete',
            data : form_data,
            dataType : 'json',
            success : function(data) {
                if(data.redirect) {
                    window.location = data.redirect;
                }
            }
        });
    })(j2store.jQuery);
}
function deleteSingle(upload_id,order_id){
    (function ($) {
        $.ajax({
            type : 'post',
            url :  j2storeURL+'index.php?option=com_j2store&view=apps&task=view&id=<?php echo $this->vars->id;?>&appTask=singleDelete',
            data : 'upload_id=' + upload_id + '&order_id='+order_id+'&id=<?php echo $this->vars->id;?>',
            dataType : 'json',
            success : function(data) {
                if(data.redirect) {
                    window.location = data.redirect;
                }
            }
        });
    })(j2store.jQuery);
}
</script>
