<?php
/**
 * --------------------------------------------------------------------------------
 * Apps Plugin - order files
 * --------------------------------------------------------------------------------
 * @package     Joomla 3.x
 * @subpackage  J2 Store
 * @author      Alagesan, J2Store <support@j2store.org>
 * @copyright   Copyright (c) 2016 J2Store . All rights reserved.
 * @license     GNU/GPL license: http://www.gnu.org/licenses/gpl-2.0.html
 * @link        http://j2store.org
 * --------------------------------------------------------------------------------
 *
 * */
/** ensure this file is being included by a parent file */
defined('_JEXEC') or die('Restricted access');

?>
<div class="orferfilescontainer">
<div id="progress-wrp<?php echo $vars->count?>">
    <div class="progress-bar"></div >
    <div class="status">0%</div>
</div>
<form action="index.php" class="form-horizontal apporderfileForm<?php echo $vars->count?>" id="apporderfileForm<?php echo $vars->count?>" enctype="multipart/form-data">
    <div id="apporder_control_group">
        <label><?php echo JText::_('J2STORE_APP_ORDERFILE_UPLOAD_FILE');?></label>
        <input id="inputCertificate<?php echo $vars->count?>" name="orderfile<?php echo $vars->count?>" type="file" style="display:block"/>
    </div>
    <div class="apporder-notification<?php echo $vars->count?>">
    </div>
</form>
</div>

<style>
    .orferfilescontainer {
    margin-top:10px;
    padding: 5px;
    background: #eee;
    border: 1px dashed #aaa;
    }
    .orferfilescontainer label {
    font-size:18px;
    line-height:28px;
    }
    #progress-wrp<?php echo $vars->count?> {
        border: 1px solid #0099CC;
        padding: 1px;
        position: relative;
        border-radius: 3px;
        margin: 10px;
        text-align: left;
        background: #fff;
        box-shadow: inset 1px 3px 6px rgba(0, 0, 0, 0.12);
    }
    #progress-wrp<?php echo $vars->count?> .progress-bar{
        height: 20px;
        border-radius: 3px;
        background-color: #81D081;
        width: 0;
        box-shadow: inset 1px 1px 10px rgba(0, 0, 0, 0.11);
    }
    #progress-wrp<?php echo $vars->count?> .status{
        top:3px;
        left:50%;
        position:absolute;
        display:inline-block;
        color: #000000;
        line-height:20px;
    }
</style>

<script type="text/javascript">
    (function($) {
        $(document).ready(function(){
            var lat_html = $('#apporderfileForm<?php echo $vars->count?>');
            var lat_progress = $('#progress-wrp<?php echo $vars->count?>');
            if($('#<?php echo $vars->div_id;?> .apporderfileForm<?php echo $vars->count?>').length){
                $('#<?php echo $vars->div_id;?> .apporderfileForm<?php echo $vars->count?>').remove();
                $('#<?php echo $vars->div_id;?> #progress-wrp<?php echo $vars->count?>').remove();
            }

            $(lat_html).insertAfter('input[name=\'<?php echo $vars->after_display;?>\']');
            $(lat_progress).insertAfter(lat_html);
        });

        //grab your file object from a file input
        $(document).on('change', 'input[name=\'orderfile<?php echo $vars->count;?>\']', function() {

            var file_data = this.files[0];
            var form_data = new FormData();
            form_data.append('file', file_data);
            var bar_id = '#progress-wrp<?php echo $vars->count?>';
            sendFile<?php echo $vars->count?>(form_data,bar_id);
        });

    })(j2store.jQuery);

    function sendFile<?php echo $vars->count?>(form_data,progress_bar_id) {
        (function($) {
            $('.apporder-notification<?php echo $vars->count;?>').html('');
            $(progress_bar_id +" .progress-bar").css("width", + 0 +"%");
            $(progress_bar_id + " .status").text(0 +"%");
            $.ajax({
                type: 'post',
                url: 'index.php?option=com_j2store&view=apps&task=view&id=<?php echo $vars->id?>&appTask=uploadOrderfile',
                dataType: 'json',  // what to expect back from the PHP script, if anything
                cache: false,
                contentType: false,
                processData: false,
                data: form_data,
                xhr: function () {
                    //upload Progress
                    var xhr = $.ajaxSettings.xhr();
                    if (xhr.upload) {
                        xhr.upload.addEventListener('progress', function(event) {
                            var percent = 0;
                            var position = event.loaded || event.position;
                            var total = event.total;
                            if (event.lengthComputable) {
                                percent = Math.ceil(position / total * 100);
                            }
                            //update progressbar
                            $(progress_bar_id +" .progress-bar").css("width", + percent +"%");
                            $(progress_bar_id + " .status").text(percent +"%");
                        }, true);
                    }
                    return xhr;
                },
                success: function(response){
                    var html ='';
                    if(response['success']){
                        html +='<p class=\'alert alert-success notify-success\'>';
                        html += response['name'] + ' ' +response['success'] ;
                        html +='<input type=\'hidden\' value=\''+response['upload_id']+'\' name=\'orderfile<?php echo $vars->count;?>_id\' />';
                        html +='</p>';
                        $('#<?php echo $vars->button_id;?>').removeAttr('disabled');
                    }else{
                        html +='<p class=\'alert alert-error notify-error\'>';
                        html += response['error'];
                        html +='</p>';
                        $('#input[name=\'orderfile<?php echo $vars->count;?>\']').val('');
                        $('#<?php echo $vars->button_id;?>').removeAttr('disabled');
                        percent = 0;
                        $(progress_bar_id +" .progress-bar").css("width", + percent +"%");
                        $(progress_bar_id + " .status").text(percent +"%");
                    }

                    $('.apporder-notification<?php echo $vars->count;?>').html(html);

                }
            });
        })(j2store.jQuery);
    }

</script>
