<?php
/**
 * @package J2Store
 * @copyright Copyright (c)2014-17 Ramesh Elamathi / J2Store.org
 * @license GNU GPL v3 or later
 */
/** ensure this file is being included by a parent file */
defined('_JEXEC') or die('Restricted access');

require_once(JPATH_ADMINISTRATOR.'/components/com_j2store/library/plugins/app.php');

class plgJ2Storeapp_rscomments extends J2StoreAppPlugin
{
	/**
	 * @var $_element  string  Should always correspond with the plugin's filename,
	 *                         forcing it to be unique
	 */
    var $_element   = 'app_rscomments';

	/**
	 * Overriding
	 *
	 * @param $options
	 * @return unknown_type
	 */
	function onJ2StoreGetAppView( $row )
	{
		if (!$this->_isMe($row))
		{
			return null;
		}
		$html = $this->viewList();
		return $html;
	}
    /**
     * Validates the data submitted based on the suffix provided
     * A controller for this plugin, you could say
     *
     * @param $task
     * @return html
     */
    function viewList()
    {
    	$app = JFactory::getApplication();
    	$option = 'com_j2store';
    	$ns = $option.'.app.'.$this->_element;
    	$html = "";
    	JToolBarHelper::title(JText::_('J2STORE_APP').'-'.JText::_('PLG_J2STORE_'.strtoupper($this->_element)),'j2store-logo');
    	JToolBarHelper::apply('apply');
    	JToolBarHelper::save();
    	JToolBarHelper::back('PLG_J2STORE_BACK_TO_APPS', 'index.php?option=com_j2store&view=apps');
    	JToolBarHelper::back('J2STORE_BACK_TO_DASHBOARD', 'index.php?option=com_j2store');
    	$vars = new JObject();
    	//model should always be a plural
    	$this->includeCustomModel('AppRSComments');

    	$model = F0FModel::getTmpInstance('AppRSComments', 'J2StoreModel');

    	$data = $this->params->toArray();
    	$newdata = array();
    	$newdata['params'] = $data;
    	$form = $model->getForm($newdata);
    	$vars->form = $form;

    	$this->includeCustomTables();

    	$id = $app->input->getInt('id', '0');
    	$vars->id = $id;
    	$vars->action = "index.php?option=com_j2store&view=app&task=view&id={$id}";
    	$html = $this->_getLayout('default', $vars);
    	return $html;
    }

    protected function canRun() {
        if (file_exists( JPATH_SITE.'/administrator/components/com_rscomments/rscomments.php' )) {
            require_once JPATH_SITE.'/components/com_rscomments/helpers/tooltip.php';
            require_once JPATH_SITE.'/components/com_rscomments/helpers/rscomments.php';

            return true;
        }

        return false;
    }

	function onAfterDisplayContent(&$article, &$params, $limitstart = 0) {
        $app	= JFactory::getApplication();
        
        //S63:
        $tmpl = $app->input->get( 'tmpl', '' );
        if ($tmpl == 'component') {return false;}
        
        // Check if RSComments! is installed
        if (!$this->canRun()) {
            return;
        }

        // Load the language file
        JFactory::getLanguage()->load('com_rscomments');
        $config = RSCommentsHelper::getConfig();
        $option = $app->input->get( 'option','');
        $view = $app->input->get( 'view','');
        $task = $app->input->get( 'task', '' );
		$doc = JFactory::getDocument ();

		$display_commant = $this->params->get('display_list',1);
		$user_id = JFactory::getUser()->id;
		$status = true;
		if(!$display_commant && !$user_id){
			$status = false;
		}
		if(!$status){
			return '';
		}

        $content	= $article->introtext.$article->fulltext;

		if ( $option == 'com_j2store' && in_array($view,array('products','producttags')) && $task == 'view') {
            $_on  = RSCommentsHelper::rscOn($content);
            $_off = RSCommentsHelper::rscOff($content);

            // Remove the {rscomments on|off}
            RSCommentsHelper::clean($article);

            // We are not allowed to show comments in these categories
            if (isset($config->categories)) {
                if ($categories = $config->categories) {
                    if (in_array($article->catid,$categories) && !$_on) {
                        return;
                    }
                }
            }
            if ($_off) {
                return;
            }

            $_template = RSCommentsHelper::getTemplate();

            // Clean the cache
            RSCommentsHelper::clearCache();

            // Load css/js data
            RSCommentsHelper::loadScripts();
            $html = RSCommentsHelper::showRSComments('com_content',$article->id,$_template, null, $_on);

			if ($this->params->get ( 'use_product_tab', 1 )) {

				$doc->addStyleSheet(JURI::root()."plugins/j2store/".$this->_element."/".$this->_element.'/css/j2rscommants.css');
				$label = JText::_ ( $this->params->get ( 'tab_display_text', 'PLG_J2STORE_APP_RSCOMMENTS_TAB_TEXT' ) );
				// we have to echo the comments
				$custom_tabs = '<div id="j2store-rscommant">';
				$custom_tabs .= $html;
				$custom_tabs .='</div>';

				echo $custom_tabs;
				// srctip to inject the jcomments
				$script = "if(typeof(j2store) == 'undefined') {
						var j2store = {};
				}
				if(typeof(j2store.jQuery) == 'undefined') {
				j2store.jQuery = jQuery.noConflict();
				}

				(function($) {
					$(document).ready(function() {
						if ($('#j2store-product-detail-tab').length > 0 ) {
							var label ='{$label}' ;
							var container = $('#j2store-product-detail-tab');
							var string =$('#j2store-rscommant').clone();
							$('#j2store-rscommant').remove();
							container.append('<li><a data-toggle=\'tab\' href=\'#j2store-rscomments\'>'+label+'</a></li>');
							$('.tab-content').append('<div itemprop=\'comments\' class=\'tab-pane\' id=\'j2store-rscomments\'></div>');
							var elements = $(string).map(function() {
								return $('#j2store-rscomments').append(this).html();
							}) ;
						}
					});
				})(j2store.jQuery);
				";
				$doc->addScriptDeclaration ( $script );
			} else {
				return $html;
			}
		}
	}


	function onContentAfterDisplay($context, &$article, &$params, $limitstart = 0)
	{
		if ($context == 'com_content.category.productlist' ) {
			return $this->onAfterDisplayContent($article, $params, $limitstart);
		}
		return '';
	}

}
