<?php
/**
 * Joomla Progressive Web App Plugin - plg_system_webkulpwa
 *
 * PHP version 7.1.11
 *
 * @category  plugin
 * @package   Joomla.Administrator
 * @author    WebKul Software Private Limited <support@webkul.com>
 * @copyright 2010 WebKul Software Private Limited
 * @license   http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @version   GIT: 1.0
 * @link      Technical Support:  Forum - http://webkul.com/ticket
 */

// No direct access to this file
defined('_JEXEC') or die('Restricted access');

/**
 * Class for PlgSystemWebkulPWA System Plugin
 *
 * @category System
 * @package  WebkulPWA
 * @author   WebKul Software Private Limited <support@webkul.com>
 * @license  http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @link     Technical Support: Forum - http://webkul.com/ticket
 */
class PlgSystemWebkulPWA extends JPlugin
{
    /**
     * Constructor for class PlgSystemWebkulPWA
     *
     * @param object $subject Subject
     * @param object $config  Config
     */
    public function __construct($subject, $config)
    {
        parent::__construct($subject, $config);
        $lang  =JFactory::getLanguage();
        $lang->load('plg_system_webkulpwa', dirname(__FILE__));
    }
    public function onExtensionAfterSave($context, $table)
    {
        $app = JFactory::getApplication();
        $chkPlugin=$table->element;

        if ($chkPlugin == 'webkulpwa') {
            jimport('joomla.filesystem.file');
            $params = $this->params;
            $filePath = JPATH_PLUGINS. '/system/webkulpwa/manifest.json';
            $fileString     = new StdClass();

            $fileString->name               = $params->get('name');
            $fileString->short_name         = $params->get('short_name');
            $fileString->start_url          = JURI::root();
            $fileString->theme_color        = $params->get('theme_color');
            $fileString->background_color   = $params->get('background_color');


            $appIcons = array();
            // if (!empty($params->get('image_16'))) {
            //     $image_16Type   = 'image/' . explode('.', basename($params->get('image_16')))[1];
            //     $image_16URL    = JURI::root().$params->get('image_16');
            //     $appIcons[]     = array(
            //         'src'   => $image_16URL,
            //         'type'  => $image_16Type,
            //         'sizes' => '16x16'
            //     );
            // }
            // if (!empty($params->get('image_32'))) {
            //     $image_32Type   = 'image/' . explode('.', basename($params->get('image_32')))[1];
            //     $image_32URL    = JURI::root().$params->get('image_32');
            //     $appIcons[]     = array(
            //         'src'   => $image_32URL,
            //         'type'  => $image_32Type,
            //         'sizes' => '32x32'
            //     );
            // }
            // if (!empty($params->get('image_144'))) {
            //     $image_144Type  = 'image/' . explode('.', basename($params->get('image_144')))[1];
            //     $image_144URL   = JURI::root().$params->get('image_144');
            //     $appIcons[]     = array(
            //         'src'   => $image_144URL,
            //         'type'  => $image_144Type,
            //         'sizes' => '144x144'
            //     );
            // }
            if (!empty($params->get('image_192'))) {
                $image_192Type  = 'image/' . explode('.', basename($params->get('image_192')))[1];
                $image_192URL   = JURI::root().$params->get('image_192');
                $appIcons[]     = array(
                    'src'   => $image_192URL,
                    'type'  => $image_192Type,
                    'sizes' => '192x192'
                );
            }
            if (!empty($params->get('image_512'))) {
                $image_512Type  = 'image/' . explode('.', basename($params->get('image_512')))[1];
                $image_512URL   = JURI::root().$params->get('image_512');
                $appIcons[]     = array(
                    'src'   => $image_512URL,
                    'type'  => $image_512Type,
                    'sizes' => '512x512'
                );
            }

            $fileString->display       = 'fullscreen'/*$params->get('display','standalone')*/;
            $fileString->icons         = $appIcons;
            //for push notifications : these settings are also saved in web push notification extension but if both(pwa and push notifictions) the applications are used then there are two manifest from which first linked will be used.
            //We need to link pwa manifest always before push notification :  this may be achived by reordering the plugins in Joomla.
            //TODO : Implement Better way to manage both the maniest files.
            $fileString->gcm_sender_id = $this->params->get('fcm_sender_id','');

            $fileString = json_encode($fileString);
            $result     = JFile::write($filePath, $fileString);
            if ($result) {
                chmod($filePath, 0644);
                return true;
            } else {
                return false;
            }
        }
    }


    /**
     * Joomla Core System Plugin Event
     *
     * @return void
     */
    public function onBeforeCompileHead()
    {
        $app = JFactory::getApplication();
        $document   = JFactory::getDocument();
        if ($app->issite()) {
            //add manifest
            $siteName       = $this->params->get('name');
            $themeColor     = $this->params->get('theme_color');
            $document->addHeadLink("plugins/system/webkulpwa/manifest.json", 'manifest', 'rel');
            $customTag  = '<meta name="theme-color" content="'.$themeColor.'">';
            $document->addCustomTag($customTag);
            $document->addScriptDeclaration(
                '
                    var cacheName     = "'.$siteName.'";
                    var filesToCache  = [
                        "/",
                        "/index.html"
                    ];
                    var wkSiteUrl     = "'.JURI::root().'";
                '
            );

            $document->addScript(JURI::root() . 'plugins/system/webkulpwa/assets/js/webkulpwa.js');
            $style = '#wkpwa-loader-overlay {
                display:none;
                position:fixed;
                top:0px;
                left:0px;
                bottom:0px;
                right:0px;
                z-index:999999;
                background:rgba(54, 25, 25, 0.2) none repeat scroll 0 0;
                text-align: center;
            }
            #wkpwa-loader{
                top:50%;
                position:relative;
                color:#fff;
                font-size: 18px;
                z-index: 9999999;
            }
            #webkulpwa_offline_bar {
                display:none;
                background-color: red;
                position: fixed;
                bottom: 0px;
                left: 0;
                right: 0;
                max-height: 30px;
                text-align: center;
                z-index: 9999999;
                font-size: 20px;
                font-weight:bold;
                color:#fff;
                padding: 3px;
                opacity:0.5;
            }';
            if ($this->params->get('pwaloader_enable') && ($this->params->get('pwaloader_type') == 'default' || ($this->params->get('pwaloader_type') == 'custom' && !$this->params->get('wkpwaloader_custom')) )) {
                $loaderColor = $this->params->get('wkpwaloader_color','#3da9f2');
                $style .=
                    '
                    .cp-spinner{
                        width:48px;
                        height:48px;
                        display:inline-block;
                        box-sizing:border-box;
                        position:relative
                    }
                    .cp-skeleton{
                        border-radius:50%;
                        border-top:solid 6px '.$loaderColor.';
                        border-right:solid 6px transparent;
                        border-bottom:solid 6px transparent;
                        border-left:solid 6px transparent;
                        animation:cp-skeleton-animate 1s linear infinite
                    }
                    .cp-skeleton:before{
                        border-radius:50%;
                        content:" ";
                        width:48px;
                        height:48px;
                        display:inline-block;
                        box-sizing:border-box;
                        border-top:solid 6px transparent;
                        border-right:solid 6px transparent;
                        border-bottom:solid 6px transparent;
                        border-left:solid 6px '.$loaderColor.';
                        position:absolute;
                        top:-6px;
                        left:-6px;
                        transform:rotateZ(-30deg)
                    }
                    .cp-skeleton:after{
                        border-radius:50%;
                        content:" ";
                        width:48px;
                        height:48px;
                        display:inline-block;
                        box-sizing:border-box;
                        border-top:solid 6px transparent;
                        border-right:solid 6px '.$loaderColor.';
                        border-bottom:solid 6px transparent;
                        border-left:solid 6px transparent;
                        position:absolute;
                        top:-6px;
                        right:-6px;
                        transform:rotateZ(30deg)
                    }
                    @keyframes cp-skeleton-animate{
                        0%{
                            transform:rotate(0);
                            opacity:1
                        }
                        50%{
                            opacity:.7
                        }
                        100%{
                            transform:rotate(360deg);
                            opacity:1
                        }
                    }

                ';
            }

            $document->addStyleDeclaration($style);
            //check for service worker and move to root if necessary
            $serviceWorkerFile  = JPATH_PLUGINS.'/system/webkulpwa/assets/js/wkpwa_sw.js';
            if (!JFile::exists(JPATH_SITE . '/wkpwa_sw.js')) {
                JFile::copy($serviceWorkerFile, JPATH_SITE.'/wkpwa_sw.js');
            }
        }
    }

    /**
     * Joomla Core System Plugin Event
     *
     * @return void
     */
    public function onAfterRender()
    {
        $app = JFactory::getApplication();
        if ($app->issite()) {
            $dataToAppend   = '<div id="webkulpwa_offline_bar">'.JText::_('OFFLINE_SITE_TEXT').'</div>';
            if ($this->params->get('pwaloader_enable', 1)) {
                $dataToAppend .='<div id="wkpwa-loader-overlay"><div id="wkpwa-loader">';
                if ($this->params->get('pwaloader_type', 'default') == 'custom' && $this->params->get('wkpwaloader_custom', '')) {
                    $dataToAppend.='<div class="wkpwa-loader-custom"><img src="'.$this->params->get('wkpwaloader_custom','').'"></div>';
                } else {
                    $dataToAppend.='<div class="cp-spinner cp-skeleton"></div>';
                }
                $dataToAppend.='</div></div>';
            }
            $client     = $client = new JApplicationWebClient();
            $browser    = $client->browser;
            $modalBody  = JResponse::getBody();
            $body       = preg_replace('/<\/body>/', $dataToAppend."</body>", $modalBody);
            JResponse::setBody($body);
        }
    }
}
?>